package com.dxhy.core.dao.mailGather;

import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.dxhy.core.model.mailGather.EmailMaintainVo;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

import java.util.List;
import java.util.Map;


@Mapper
public interface EmailMaintainDao extends BaseMapper<EmailMaintainVo> {


    /**
     * 通过ID查询单条数据
     *
     * @param id 主键
     * @return 实例对象
     */
    List<EmailMaintainVo> queryAll();

    /**
     * 查询指定行数据
     *
     * @param pramsMap 查询条件
     * @return 对象列表
     */
    List<EmailMaintainVo> queryAllByLimit(Map<String, Object> pramsMap);

    /**
     * 统计总行数
     *
     * @param emailMaintainVo 查询条件
     * @return 总行数
     */
    EmailMaintainVo getEmailMaintainVo(EmailMaintainVo emailMaintainVo);

    /**
     * 新增数据
     *
     * @param emailMaintainVo 实例对象
     * @return 影响行数
     */
    int insert(EmailMaintainVo emailMaintainVo);

    /**
     * 批量新增数据（MyBatis原生foreach方法）
     *
     * @param entities List<EmailMaintainVo> 实例对象列表
     * @return 影响行数
     */
    int insertBatch(@Param("entities") List<EmailMaintainVo> entities);

    /**
     * 批量新增数据（MyBatis原生foreach方法）
     *
     * @param entities List<EmailMaintainVo> 实例对象列表
     * @return 影响行数
     */
    int selectByEmail(@Param("email") String email);

    /**
     * 批量新增或按主键更新数据（MyBatis原生foreach方法）
     *
     * @param entities List<EmailMaintainVo> 实例对象列表
     * @return 影响行数
     * @throws org.springframework.jdbc.BadSqlGrammarException 入参是空List的时候会抛SQL语句错误的异常，请自行校验入参
     */
    int insertOrUpdateBatch(@Param("entities") List<EmailMaintainVo> entities);

    /**
     * 修改数据
     *
     * @param emailMaintainVo 实例对象
     * @return 影响行数
     */
    int update(EmailMaintainVo emailMaintainVo);

    /**
     * 通过主键删除数据
     *
     * @param id 主键
     * @return 影响行数
     */
    int deleteById(String id);


    String getUserName(@Param("userCode") String userCode);
    String getUserByUsername(@Param("username") String username);

}
